/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             Smart pointer management
*  SCOPE :              Smart pointer management
*  FILE :               smartp_tmpl.hxx
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif
#ifndef __smartp_tmpl_HXX
#define __smartp_tmpl_HXX

/* IMPORTS *******************************************************************/

/*****************************************************************************/


template <class x> class Ref : public yoo_ObjectX {                    
  public :
  Ref() {}
  Ref(OID oid) : yoo_ObjectX(oid) {} ;
  Ref(x* e) : yoo_ObjectX(e) {} ;
  x* operator->() const {
    PageHdlMem* pd ;
    return (x*)
      ((pd=(PageHdlMem*)YOO_VirtualMemory->_inVMPagePID[_oid])!=NULL?
       pd->_page->object(_oid.objNo) :
       YOO_VirtualServer->findPage(this->_oid)->object(_oid.objNo)) ;
  }
  x& operator*() const {
    return *this->operator->() ;
  }
  operator x*() const {
    return this->_oid==NULL_OID? NULL : this->operator->();
  }
  class Ref<x>& operator=(x* obj) {
    this->assign(obj); return *this;
  }
} ;


#endif

